#include <stdio.h>
#include <limits.h>

//podzadatak (a)

//pomocna funkcija koja vraca broj djelitelja (prir. brojeva) broja x
int brDj(int x) {
	int i, broj = 0;

	x = ( x < 0 ) ? -x : x;
	if(x == 0) // nula ima sve moguce djelitelje
		return INT_MAX; // ili staviti nesto jako veliko

    //sad izbrojimo djelitelje broja x
	for(i = 1; i <= x; ++i)
		if(x % i == 0)
			++broj;

	return broj;
}

//pomocna funkcija koja provjerava je li (prirodan) broj x prost
int prost(int x) { //vraca 1 ako je x prost, inace vraca 0
    int jestProst = 1, i;
    if(x == 1)
        return 0; // 1 nije prost broj!
    for(i = 2; i < x; ++i)
        if(x % i == 0) //nasli djelitelja koji nije 1 ni x, pa broj nije prost
            return 0;

    return 1; //broj je prost
}

//pomocna funkcija za broj prostih znamenki broja x
int prosteZnamenke(int x) {
    int broj = 0;
    while(x > 0){ //za svaku znamenku, ako je prosta povecati brojac
        if(prost(x % 10) == 1)
            broj++;
        x /= 10;
    }
    return broj;
}


void sortiraj(int BR[], int n)
{
	int i, j, temp;

	for(i = 0; i < n; ++i )
		for(j = i+1; j < n; ++j )
			if(brDj(BR[i]) < brDj(BR[j]) ||
			    brDj(BR[i]) == brDj(BR[j]) && prosteZnamenke(BR[i]) > prosteZnamenke(BR[j]))
			{
				temp = BR[i];
				BR[i] = BR[j];
				BR[j] = temp;
			}
}


//podzadatak (b)

int main(void){
	int BR[2021], i, a, b, lo = 0 /*prvi indeks*/,
	hi = 2020 /*zadnji indeks*/, mid, index = -1;

	//ucitavanje niza BR
	for(i = 0; i < 2021; ++i)
        scanf("%d", &BR[i]);

	//sortiramo niz BR
	sortiraj(BR, 2021);

	//ucitamo (prirodne) brojeve a i b
	scanf("%d %d", &a, &b);

    //binarno pretrazivanje
	while(lo <= hi)
	{
		mid = (lo + hi) / 2;
		if(brDj(BR[mid]) == a && prosteZnamenke(BR[mid]) == b) {
			index = mid;
			break;
		}
		else if(brDj(BR[mid]) < a ||
		         brDj(BR[mid]) == a && prosteZnamenke(BR[mid]) > b)
			hi = mid - 1; //idemo lijevo
		else
			lo = mid + 1; //idemo desno
	}

	printf("%d\n", index);

	return 0;
}
